/*
  Title:    naked.h
  Author:   samson
  Date:     apr 15, 2002
  Purpose:  naked function support - intended for naked interrupts
  needed
  Software: AVR-GCC
  needed
  Hardware: ATS90S2313
*/

#ifndef __NAKED_H__
#define __NAKED_H__

#ifdef __cplusplus
#define NAKED(signame)					                \
extern "C" void signame(void);				          \
void signame (void) __attribute__ ((naked));		\
void signame (void)
#else
#define NAKED(signame)					                \
void signame (void) __attribute__ ((naked));		\
void signame (void)
#endif

// ret assembly variants
#define ret()       __asm__ __volatile__ ("ret"     ::)
#define reti()      __asm__ __volatile__ ("reti"    ::)

// push and pop r0 and r1 as special cases
#define pushR0()    __asm__ __volatile__ ("push r0" ::)
#define popR0()     __asm__ __volatile__ ("pop r0"  ::: "r0")

#define pushR1()    __asm__ __volatile__ ("push r1" ::)
#define popR1()     __asm__ __volatile__ ("pop r1"  ::: "r1")

// push and pop variables in arbitrary registers or memory mapped registers
#define pushREG(pR) __asm__ __volatile__ ("push %0" : "=r" (pR) :)
#define popREG(pR)  __asm__ __volatile__ ("pop %0"  : "=&r" (pR) :)

#define pushMEM(pM) __asm__ __volatile__ ("in r0, %0"  "\n\t" \
                                          "push r0"    "\n\t" :: "M" (pM) : "r0")
#define popMEM(pM)  __asm__ __volatile__ ("pop r0"     "\n\t" \
                                          "out %0, r0" "\n\t" :: "M" (pM) : "r0")


#endif // __NAKED_H__
