/*
    Title:    UART library
    Author:   Volker Oth
    Date:     5/1999
    Purpose:  Sending a block of data to uart.
    needed
    Software: AVR-GCC to compile, AVA to assemble and link
    needed
    Hardware: ATS90S8515 on STK200 board
    Note:     To contact me, mail to
                  volkeroth@gmx.de
              You might find more AVR related stuff at my homepage:
                  http://members.xoom.com/volkeroth
*/

#ifndef UART_H
#define UART_H

#include "types.h"

/* set baud rate here */
#define UART_BAUD_RATE   19200
#define ESC              0x1b
#define UART_INBUF_SIZE  6
#define UART_OUTBUF_SIZE 12


/* automatically calcuate baud register value */
#define UART_BAUD_SELECT (F_CPU/(UART_BAUD_RATE*16L)-1)


/* prototypes */
extern void uart_init(void);

extern BYTE uart_getchar(void);

extern bool uart_putchar(BYTE c);

extern void uart_putstr(BYTE s[]);

#endif 
